/*
 *	void memCopy(*d,*s,len);		// SRAM to SRAM copy
 *
 *	: len1`127܂.	(tiny2313SRAM128oCgȂ̂.)
 *		  len <= 0 ̂Ƃ͉Ȃ.
 */

/*************************************************************/
	.text
	.global	memCopy
	.type	memCopy, @function

memCopy:
	cp r1,r20	/* __zero_reg__,r20 */
	brge .L4

	movw r26,r24
	movw r30,r22

.L3:
	ld		r24,Z+
	st		X+,r24
	subi	r20,1
	brne	.L3
.L4:
	ret

/*************************************************************/
/*
 *	void  baud_calc(int baud_l,uchar baud_h);
 *
 *	{[[g bbr̒l߂.
 *	UBRRL,UBRRHɐݒ肷.
 *
 */
	.global	baud_calc
	.type	baud_calc, @function
//	-----------------------------------------------------------------------
//
//	ubrr = ( r / baud ) - 1 ߂.
//	:
//	   baud:  r22:r25:r24  17bit. {[[ĝ.(r22͉1bit̂ݎgp)
//	ϐ:
//	   r:     r22:r21:r20  24bit  萔F USARTɗ^NbN/2.
//	   i:	      r19:r18  16bit. {[[g̋t. UBRRɃZbgl.
//	:
//	   (-1) => i  UBRR ɏŖ߂(void)
//	-----------------------------------------------------------------------

baud_calc:
	// 24bit baud >>1 .
	lsr r22
	ror r25
	ror r24

	// r = 12000000/8/2; 	USARTɗ^NbN/2.(U2X=1̂Ƃ)
	ldi r20,0xb0	// 0x0b71b0 = 12000000/8/2 = 750000
	ldi r21,0x71
	ldi r22,0x0b

	// i = (-2);		ȉ̃[vłȉl (-1).
	ldi r18,lo8(-2)	//  AAʂƂ-1̂ŁA(-2)^.
	ldi r19,hi8(-2)

	// i = (r/b) ̊ZZ[vŎs.
.L8:
	// i++;
	subi r18,lo8(-(1))
	sbci r19,hi8(-(1))

	// r = r - b;	   24biẗZs.
	sub r20,r24
	sbc r21,r25
	sbc r22,r1		// baud16bitȂ̂ bit23:16  [Œ.
	brcc .L8		// ܂.
.L9:
	out 34-0x20,r19	// UBRRH(0x02)
	out 41-0x20,r18	// UBRRL(0x09)

	ret

#if	0

#define	int24 long

int baud_calc(int baud)
{
	int24 r = 12000000/8/2;
	baud /= 2;
	baud &= 0xffff;

	int i=-2;	// l=-1,Ɍʂ -1 .
	do {
		i++;
		r -= baud;
	}while(r>=0);
	return i;
}
#endif
/*************************************************************/
